import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkAuthRule, ThinkAuthRuleParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkAuthRule(params: ThinkAuthRuleParam) {
  const res = await request.get<ApiResult<PageResult<ThinkAuthRule>>>(
    THINK_API_URL + '/think/think-auth-rule/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkAuthRule(params?: ThinkAuthRuleParam) {
  const res = await request.get<ApiResult<ThinkAuthRule[]>>(
    THINK_API_URL + '/think/think-auth-rule',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkAuthRule(data: ThinkAuthRule) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-auth-rule',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkAuthRule(data: ThinkAuthRule) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-auth-rule',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkAuthRule(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-auth-rule/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkAuthRule(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-auth-rule/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkAuthRule(id: number) {
  const res = await request.get<ApiResult<ThinkAuthRule>>(
    THINK_API_URL + '/think/think-auth-rule/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
